import _classCallCheck from "@babel/runtime/helpers/classCallCheck";
import _createClass from "@babel/runtime/helpers/createClass";
import _possibleConstructorReturn from "@babel/runtime/helpers/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/getPrototypeOf";
import _inherits from "@babel/runtime/helpers/inherits";
import _typeof from "@babel/runtime/helpers/typeof";

var __decorate = this && this.__decorate || function (decorators, target, key, desc) {
  var c = arguments.length,
      r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc,
      d;
  if ((typeof Reflect === "undefined" ? "undefined" : _typeof(Reflect)) === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);else for (var i = decorators.length - 1; i >= 0; i--) {
    if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
  }
  return c > 3 && r && Object.defineProperty(target, key, r), r;
};

import * as React from 'react';
import AvartarImg from '../../../../../components/common/avatarImg';
import { jumpPerson } from '../../../../../helper/jumpToPersonHome';
import ScrollWrap from '../../../../../components/common/scrollWrap';
import { getApiUrl, taker, getUserInfo } from '../../../../../helper';
import NoDataView from '../../../../../components/common/noDataView';
import widthProvider from '@beisen/react-width-provider';
import './orderList.css';
import ToolTip from '@beisen/tool-tip';

var ListItem =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ListItem, _React$Component);

  function ListItem(p) {
    var _this;

    _classCallCheck(this, ListItem);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ListItem).call(this, p));

    _this.handleThumbClick = function () {
      //点赞(接口返回再允许第二次点击)
      if (_this.isfetching) return;
      var _this$state = _this.state,
          ThumbUpCount = _this$state.ThumbUpCount,
          CanThumbUp = _this$state.CanThumbUp;
      var _this$props = _this.props,
          data = _this$props.data,
          fanwei = _this$props.fanwei;
      _this.isfetching = true;
      var urlStr = '';

      if (!CanThumbUp) {
        //取消赞
        urlStr = 'proxy/PostUPaaSCoreGateway/Like/CancelLike';
      } else {
        //点赞
        urlStr = 'proxy/PostUPaaSCoreGateway/Like/Like';
      }

      var url = getApiUrl(urlStr);
      var mapDianZan = [0, 1, 1, 2, 3, 4];
      taker(url, 'POST', {
        appObj: {
          AppObjId: data.User.UserId,
          AppObjType: 9501005,
          PeriodType: mapDianZan[fanwei],
          ReceiverId: data.User.UserId
        }
      }).then(function (res) {
        _this.timeOut && clearTimeout(_this.timeOut);
        _this.timeOut = setTimeout(function () {
          _this.isfetching = false;
        }, 300);

        if (res.Code == 200) {
          //点赞｜取消赞结束，改状态。
          _this.setState({
            CanThumbUp: !CanThumbUp,
            ThumbUpCount: CanThumbUp ? ThumbUpCount + 1 : ThumbUpCount - 1
          });
        }
      });
    };

    _this.goSelfPage = function () {
      var data = _this.props.data;
      jumpPerson(data.User.UserId, 1);
    };

    _this.state = {
      CanThumbUp: p.data.CanThumbUp,
      ThumbUpCount: p.data.ThumbUpCount
    };
    return _this;
  }

  _createClass(ListItem, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(np) {
      var npCount = np.data.ThumbUpCount;
      var npCan = np.data.CanThumbUp;
      var _this$props$data = this.props.data,
          ThumbUpCount = _this$props$data.ThumbUpCount,
          CanThumbUp = _this$props$data.CanThumbUp;

      if (npCan != CanThumbUp || npCount != ThumbUpCount) {
        this.setState({
          CanThumbUp: npCan,
          ThumbUpCount: npCount
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          data = _this$props2.data,
          index = _this$props2.index,
          width = _this$props2.width;
      var _this$state2 = this.state,
          ThumbUpCount = _this$state2.ThumbUpCount,
          CanThumbUp = _this$state2.CanThumbUp;
      var userInfo = getUserInfo();
      var isSelf = userInfo.Id == data.User.UserId;
      return React.createElement("tr", {
        className: 'list-item'
      }, React.createElement("td", {
        className: "icon order".concat(index)
      }, index > 2 ? index + 1 : ''), React.createElement("td", null), React.createElement("td", {
        className: 'head',
        onClick: this.goSelfPage
      }, React.createElement(AvartarImg, {
        size: 30,
        color: data.User.Avatar.Color,
        name: data.User.Name,
        src: data.User.Avatar.Original
      })), React.createElement("td", null), React.createElement("td", {
        className: 'name',
        onClick: this.goSelfPage
      }, React.createElement(ToolTip, {
        side: false,
        title: data.User.Name
      }, React.createElement("span", null, data.User.Name))), React.createElement("td", null), React.createElement("td", {
        className: 'describe',
        style: {
          display: width && width <= 290 ? 'none' : 'table-cell'
        }
      }, React.createElement("span", {
        className: 'des-describe'
      }), React.createElement("span", {
        className: 'des-time'
      }, "".concat(data.RankBasis > 99 ? '99+' : data.RankBasis), "\u6B21")), React.createElement("td", {
        className: 'agree-number'
      }, React.createElement("div", {
        className: 'agree-container'
      }, React.createElement("span", {
        className: "agree font-agree ".concat(CanThumbUp ? '' : 'agreed', " ").concat(isSelf ? 'self-agree' : ''),
        onClick: function onClick() {
          !isSelf && _this2.handleThumbClick();
        }
      }), React.createElement("span", {
        className: 'agree-count'
      }, "".concat(ThumbUpCount > 99 ? '99+' : ThumbUpCount)))));
    }
  }]);

  return ListItem;
}(React.Component);

var OrderList =
/*#__PURE__*/
function (_React$Component2) {
  _inherits(OrderList, _React$Component2);

  function OrderList() {
    _classCallCheck(this, OrderList);

    return _possibleConstructorReturn(this, _getPrototypeOf(OrderList).apply(this, arguments));
  }

  _createClass(OrderList, [{
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          datas = _this$props3.datas,
          fanwei = _this$props3.fanwei,
          width = _this$props3.width;

      if (!datas.length) {
        return React.createElement("div", {
          className: 'list-no-data'
        }, React.createElement(NoDataView, {
          icon: 2
        }));
      }

      var name = datas[0].User.Name;
      datas.map(function (d, k) {
        if (d.User.Name.length > name.length) {
          name = d.User.Name;
        }
      });
      return React.createElement("div", {
        className: 'bound-order-lists'
      }, React.createElement(ScrollWrap, {
        height: '100%'
      }, React.createElement("table", {
        className: 'order-table'
      }, React.createElement("colgroup", null, React.createElement("col", {
        width: '20px'
      }), React.createElement("col", {
        width: '20px'
      }), React.createElement("col", {
        width: '30px'
      }), React.createElement("col", {
        width: '10px'
      }), React.createElement("col", {
        width: '20px'
      }), React.createElement("col", {
        width: '27px'
      }), React.createElement("col", {
        width: '0px'
      }), React.createElement("col", {
        width: '35px'
      })), React.createElement("tbody", null, datas.map(function (data, index) {
        return React.createElement(ListItem, {
          data: data,
          index: index,
          key: "list-item".concat(index),
          fanwei: fanwei,
          width: width
        });
      })))));
    }
  }]);

  return OrderList;
}(React.Component);

OrderList = __decorate([widthProvider('width')], OrderList);
export default OrderList;